'use strict';

var _knex = require('knex');

var _knex2 = _interopRequireDefault(_knex);

var _fluentRecord = require('fluent-record');

var _fluentRecord2 = _interopRequireDefault(_fluentRecord);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var knex = (0, _knex2.default)(KNEX_CONFIG);

var fluent = (0, _fluentRecord2.default)(knex, {
  camelCaseKeys: true,
  models: {
    user: {
      tableName: 'users',
      columns: {
        id: {
          primaryKey: true,
          type: 'integer'
        },
        email: 'string',
        password: 'string'
      },
      relations: {
        playlists: {
          type: 'hasMany',
          model: 'playlist'
        },
        albums: {
          type: 'hasMany',
          model: 'album'
        }
      }
    },
    playlist: {
      tableName: 'playlists',
      relations: {
        user: {
          type: 'belongsTo',
          model: 'user'
        }
      }
    },
    track: {
      tableName: 'tracks',
      relations: {}
    },
    album: {
      tableName: 'albums',
      relations: {}
    }
  }
});